<?php

class DLM_GF_Settings {

	/**
	 * Add settings to DLM settings
	 *
	 * @param $settings
	 *
	 * @return mixed
	 */
	public static function add_settings( $settings ) {

		$settings['gravity_forms'] = array(
			__( 'Gravity Forms', 'dlm-gravity-forms' ),
			array(
				array(
					'name'    => 'dlm_gf_unlock_type',
					'std'     => '',
					'label'   => __( 'Completing form will unlock', 'dlm-gravity-forms' ),
					'desc'    => __( 'Select what should be unlocked upon completing a form. Only applies to Gravity Forms locked downloads.', 'dlm-gravity-forms' ),
					'type'    => 'select',
					'options' => array(
						'per_download' => __( 'only requested download', 'dlm-gravity-forms' ),
						'per_form'     => __( 'all downloads with the same form', 'dlm-gravity-forms' ),
						'global'       => __( 'all locked downloads', 'dlm-gravity-forms' ),
					)
				),
			)
		);

		return $settings;
	}

}