<?php
/**
 * Class Account
 * @package Unifonic\API\Account
 */
if ( !class_exists('UnifonicAccount') ) :
    Class UnifonicAccount
    {

        /**
         * @var
         */
        private $client;

        /**
         * @param $oUnifonicClient
         */
        public function __construct( $oUnifonicClient )
        {
            $this->client = $oUnifonicClient;
        }


        public function Rules( $methodName )
        {

            $rules = array(
                'GetBalance' => array(),
                'AddSenderID' => array(
                    'SenderID' => 'required',
                ),
                'GetSenderIDStatus' => array(
                    'SenderID' => 'required',
                ),
                'GetSenderIDs' => array(),
                'GetAppDefaultSenderID' => array(),
                'ChangeAppDefaultSenderID' => array(),
                'DeleteSenderID' => array(
                    'SenderID' => 'required',
                )

            );

            return $rules["$methodName"];
        }


        /**
         * @return mixed
         */
        public function GetBalance()
        {
            $aParams = array();
            $valid = UnifonicClient::is_valid($aParams, $this->Rules(__FUNCTION__));
            if ( $valid === true ) {
                return $this->client->Account_GetBalance();
            } else {
                return $valid[0];
            }
        }


        /**
         * @param $SenderID
         * @return mixed
         * @throws \Exception
         * @throws \Unifonic\API\Exception
         */
        public function AddSenderID( $SenderID )
        {
            try {
                $aParams = array('SenderID' => $SenderID);
                $valid = UnifonicClient::is_valid($aParams, $this->Rules(__FUNCTION__));
                if ( $valid === true ) {
                    return $this->client->Account_AddSenderID($aParams);
                } else {
                    return $valid[0];
                }
            } catch (Exception $e) {
                throw $e;

            }
        }

        /**
         * @param String $SenderID
         * @return stdClass
         */
        public function GetSenderIDStatus( $SenderID )
        {
            $aParams = array('SenderID' => $SenderID);
            $valid = UnifonicClient::is_valid($aParams, $this->Rules(__FUNCTION__));
            if ( $valid === true ) {
                return $this->client->Account_GetSenderIDStatus($aParams);
            } else {
                return $valid[0];
            }
        }

        /**
         * @return stdClass
         */
        public function GetSenderIDs()
        {
            $aParams = array();
            $valid = UnifonicClient::is_valid($aParams, $this->Rules(__FUNCTION__));
            if ( $valid === true ) {
                return $this->client->Account_GetSenderIDs($aParams);
            } else {
                return $valid[0];
            }
        }

        /**
         * @return stdClass
         */
        public function GetAppDefaultSenderID()
        {
            $aParams = array();
            $valid = UnifonicClient::is_valid($aParams, $this->Rules(__FUNCTION__));
            if ( $valid === true ) {
                return $this->client->Account_GetAppDefaultSenderID();
            } else {
                return $valid[0];
            }
        }

        /**
         * @param String $SenderID
         * @return stdClass
         */
        public function ChangeAppDefaultSenderID( $SenderID )
        {
            $aParams = array('SenderID' => $SenderID);
            $valid = UnifonicClient::is_valid($aParams, $this->Rules(__FUNCTION__));
            if ( $valid === true ) {
                return $this->client->ChangeAppDefaultSenderID($aParams);
            } else {
                return $valid[0];
            }

        }

        /**
         * @param String $SenderID
         * @return stdClass
         */
        public function DeleteSenderID( $SenderID )
        {
            $aParams = array('SenderID' => $SenderID);
            $valid = UnifonicClient::is_valid($aParams, $this->Rules(__FUNCTION__));
            if ( $valid === true ) {
                return $this->client->DeleteSenderID($aParams);
            } else {
                return $valid[0];
            }
        }

    }
endif;