<?php
if ( !class_exists('UnifonicClient') ) :
    class UnifonicClient
    {
        /**
         * @var Message
         */
        public $Messages;

        /**
         * @var Account
         */
        public $Account;

        /**
         * @param string $apiKey
         * @param string $apiSecret
         */
        private $API_URL = 'http://api.unifonic.com/rest/';
        private $sMethod;
        public $aParams;

        public function __construct( $AppSid = '' )
        {

            $this->APP_SID = !empty($AppSid) ? $AppSid : '';

            if ( !class_exists('UnifonicMessage') )
                include_once 'Message.php';

            $this->Messages = new UnifonicMessage($this);

            if ( !class_exists('UnifonicAccount') )
                include_once 'Account.php';

            $this->Account = new UnifonicAccount($this);
        }

        private function call()
        {


            $this->aParams['AppSid'] = $this->APP_SID;
            //open connection
            $ch = curl_init();
            //set the url, number of POST vars, POST data
            curl_setopt($ch, CURLOPT_URL, $this->API_URL . $this->sMethod);
            curl_setopt($ch, CURLOPT_POST, count($this->aParams));
            curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($this->aParams));
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            //execute post
            $result = curl_exec($ch);
            //var_dump($result);

            $http_status = curl_getinfo($ch, CURLINFO_HTTP_CODE);

            //close connection
            curl_close($ch);
            if ( !empty($http_status) && $http_status == 500 ) {
                throw new Exception('Couldn\'t Connect to API');
            }

            $aResult = json_decode($result);

            if ( !empty($aResult) && isset($aResult->success) ) {
                if ( $aResult->success == 'true' ) {
                    return $aResult->data;
                }

                $code = '';
                if ( !empty($aResult->errorCode) )
                    $code = str_replace('ER-', '', $aResult->errorCode);

                $message = !empty($aResult->message) ? $aResult->message : 'Unknown Error';

                throw new Exception($message, $code);
            }

            throw new Exception('Invalid Response');
        }

        public function __call( $methodname, $args )
        {
            if ( method_exists($this, $methodname) ) {
                return $this->$methodname();
            }

            $this->sMethod = str_replace('_', '/', $methodname);
            $this->aParams = isset($args[0]) ? $args[0] : null;
            return $this->call();
        }

        public static function is_valid( $data, $validators )
        {
            //for feature
            return true;
        }

    }
endif;