<?php

/*
 * Class Name : GFHANNANSMS_Pro_{strtoupper( php file name) }	
 */

class GFHANNANSMS_Pro_LIFETIMESMS {

	/*
	* Gateway title	
	*/
	public static function name( $gateways ) {

		$name = __( 'LifeTimeSMS', 'GF_SMS' );

		$gateway = array( strtolower( str_replace( 'GFHANNANSMS_Pro_', '', get_called_class() ) ) => $name );

		return array_unique( array_merge( $gateways, $gateway ) );
	}


	/*
	* Gateway parameters
	*/
	public static function options() {
		return array(
			'username' => __( 'Username', 'GF_SMS' ),
			'password' => __( 'Password', 'GF_SMS' ),
		);
	}

	/*
	* Gateway credit
	*/
	public static function credit() {
		return true;
	}

	/*
	* Gateway action
	*/
	public static function process( $options, $action, $from, $to, $messages ) {

		if ( $action == 'credit' && ! self::credit() ) {
			return false;
		}

		$username = $options['username'];
		$password = $options['password'];

		if ( $action == "send" ) {

			$content = "http://lifetimesms.com/plain?username=" . $username . "&password=" . $password .
			           "&to=" . $to . "&from=" . urlencode( $from ) . "&message=" . urlencode( $messages );

			if ( extension_loaded( 'curl' ) ) {
				$ch = curl_init( $content );
				curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
				$response = curl_exec( $ch );
				curl_close( $ch );
			} else {
				$response = file_get_contents( $content );
			}
			if ( empty( $response ) ) {
				return __( 'Unknown Error.', 'GF_SMS' );
			}
			$response_json = json_decode( $response, true );

			if ( ! empty( $response_json ) ) {

				if ( empty( $response_json['messages'] ) || ! is_array( $response_json['messages'] ) ) {
					return __( 'Unknown Error.', 'GF_SMS' );
				}

				$errors = array();

				foreach ( $response_json['messages'] as $message ) {

					if ( isset( $message['status'] ) && $message['status'] > 0 ) {
						continue;
					}

					$gsm    = isset( $message['gsm'] ) ? $message['gsm'] . ' => ' : '';
					$status = isset( $message['status'] ) ? $message['status'] : '';
					$error  = isset( $message['error'] ) ? ' ::: ' . $message['error'] : '';

					$errors[] = $gsm . self::error( $status ) . $error;
				}

				if ( ! empty( $errors ) ) {
					return implode( ' | ', $errors );
				}

			} else {
				$status = explode( ':', $response );
				if ( count( $status ) >= 2 ) {
					if ( strtolower( trim( $status[0] ) ) != 'ok' ) {
						return $status[1];
					}
				} else {
					return __( 'Unknown Error.', 'GF_SMS' );
				}
			}


			return 'OK';
		}


		if ( $action == "credit" ) {

			$content = "http://lifetimesms.com/credit.php?username={$username}&password={$password}";

			if ( extension_loaded( 'curl' ) ) {
				$ch = curl_init( $content );
				curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
				$response = curl_exec( $ch );
				curl_close( $ch );
			} else {
				$response = file_get_contents( $content );
			}
			if ( empty( $response ) ) {
				return __( 'Unknown Error.', 'GF_SMS' );
			}

			$status = explode( ':', $response );
			if ( count( $status ) >= 2 ) {
				return trim( $status[1] );
			}

			return $response;
		}

		if ( $action == "range" ) {
			$min = 5000;
			$max = 10000;

			return array( "min" => $min, "max" => $max );
		}

	}

	private static function error( $status ) {

		switch ( $status ) {

			case '-1':
				return __( 'Your request is incomplete and missing some mandatory parameters.', 'GF_SMS' );
				break;

			case '-2':
				return __( 'Invalid Recipient Number.', 'GF_SMS' );
				break;

			case '-3':
				return __( 'Sender ID cant Be Greater Than 11 Characters.', 'GF_SMS' );
				break;

			case '-4':
				return __( 'The Username or Password you supplied is either invalid or disabled or blocked.', 'GF_SMS' );
				break;

			case '-5':
				return __( 'Message Length Cant Be exceeded Than 612 Characters.', 'GF_SMS' );
				break;

			case '-6':
				return __( 'Balance Error.', 'GF_SMS' );
				break;

			case '-7':
				return __( 'SMS Rejected Due to spam Filters.', 'GF_SMS' );
				break;

			case '-8':
				return __( 'too many Recepients are Supplied.', 'GF_SMS' );
				break;

			case '-9':
				return __( 'Unknow error (contact with Department).', 'GF_SMS' );
				break;

			case '-10':
				return __( 'Service Down.', 'GF_SMS' );
				break;

			case '-11':
				return __( 'Invalid Date For Schedule.', 'GF_SMS' );
				break;

			default:
				return __( 'Error.', 'GF_SMS' );
				break;
		}
	}

}