<?php

/*
 * Class Name : GFHANNANSMS_Pro_{strtoupper( php file name) }	
 */

class GFHANNANSMS_Pro_MSG360 {

	/*
	* Gateway title	
	*/
	public static function name( $gateways ) {

		$name = __( 'Msg360', 'GF_SMS' );

		$gateway = array( strtolower( str_replace( 'GFHANNANSMS_Pro_', '', get_called_class() ) ) => $name );

		return array_unique( array_merge( $gateways, $gateway ) );
	}


	/*
	* Gateway parameters
	*/
	public static function options() {
		return array(
			'username' => __( 'Username', 'GF_SMS' ),
			'password' => __( 'Password', 'GF_SMS' ),
		);
	}

	/*
	* Gateway credit
	*/
	public static function credit() {
		return false;
	}

	/*
	* Gateway action
	*/
	public static function process( $options, $action, $from, $to, $messages ) {

		if ( $action == 'credit' && ! self::credit() ) {
			return false;
		}

		$username = $options['username'];
		$password = $options['password'];

		if ( $action == "send" ) {

			$to = str_ireplace( '+', '', $to );

			$messages = rawurlencode( $messages );

			$content = "http://trans.msg360.in/websms/sendsms.aspx?action=sendsms&userid={$username}&password={$password}&sender={$from}&mobileno={$to}&msg={$messages}";

			if ( extension_loaded( 'curl' ) ) {
				$ch = curl_init( $content );
				curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
				$response = curl_exec( $ch );
				curl_close( $ch );
			} else {
				$response = file_get_contents( $content );
			}

			if ( stripos( $response, 'Success' ) !== false ) {
				return 'OK';
			} else if ( stripos( $response, 'Failed' ) !== false ) {
				return trim( preg_replace( '/Failed\s*?:/is', '', $response ) );
			} else {
				return __( 'Unknown Error.', 'GF_SMS' );
			}

		}


		if ( $action == "credit" ) {

		}

		if ( $action == "range" ) {
			$min = 5000;
			$max = 10000;

			return array( "min" => $min, "max" => $max );
		}

	}

}