<?php

/*
 * Class Name : GFHANNANSMS_Pro_{strtoupper( php file name) }	
 */

class GFHANNANSMS_Pro_MSHASTRA {

	/*
	* Gateway title	
	*/
	public static function name( $gateways ) {

		$name = __( 'Mobishastra (MShastra.com)', 'GF_SMS' );

		$gateway = array( strtolower( str_replace( 'GFHANNANSMS_Pro_', '', get_called_class() ) ) => $name );

		return array_unique( array_merge( $gateways, $gateway ) );
	}


	/*
	* Gateway parameters
	*/
	public static function options() {
		return array(
			'profile_id' => __( 'Profile Id', 'GF_SMS' ),
			'password'   => __( 'Password', 'GF_SMS' ),
		);
	}

	/*
	* Gateway credit
	*/
	public static function credit() {
		return true;
	}

	/*
	* Gateway action
	*/
	public static function process( $options, $action, $from, $to, $messages ) {

		if ( $action == 'credit' && ! self::credit() ) {
			return false;
		}

		$profile_id = $options['profile_id'];
		$password   = $options['password'];

		if ( $action == "send" ) {

			//$to = str_replace( '+', '', $to );
			$messages = rawurlencode( $messages );

			$content = "http://mshastra.com/sendurlcomma.aspx?user={$profile_id}&pwd={$password}&senderid={$from}&mobileno={$to}&msgtext={$messages}&priority=High&CountryCode=ALL";

			if ( extension_loaded( 'curl' ) ) {
				$ch = curl_init( $content );
				curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
				$response = curl_exec( $ch );
				curl_close( $ch );
			} else {
				$response = file_get_contents( $content );
			}

			if ( empty( $response ) ) {
				return __( 'Unknown Error.', 'GF_SMS' );
			}

			if ( stripos( $response, 'Successful' ) !== false ) {
				return 'OK';
			}

			return $response;
		}


		if ( $action == "credit" ) {

			$content = "http://mshastra.com/balance.asp?user={$profile_id}&pwd={$password}";

			if ( extension_loaded( 'curl' ) ) {
				$ch = curl_init( $content );
				curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
				$response = curl_exec( $ch );
				curl_close( $ch );
			} else {
				$response = file_get_contents( $content );
			}

			if ( empty( $response ) ) {
				return __( 'Unknown Error.', 'GF_SMS' );
			}

			return trim( $response, ' ,' );
		}

		if ( $action == "range" ) {
			$min = 1000;
			$max = 2000;

			return array( "min" => $min, "max" => $max );
		}

	}
}