<?php

/*
 * Class Name : GFHANNANSMS_Pro_{strtoupper( php file name) }	
 */

class GFHANNANSMS_Pro_ONEWAYSMS_SG {

	/*
	* Gateway title	
	*/
	public static function name( $gateways ) {

		$name = __( 'One Way Sms (Singapore)', 'GF_SMS' );

		$gateway = array( strtolower( str_replace( 'GFHANNANSMS_Pro_', '', get_called_class() ) ) => $name );

		return array_unique( array_merge( $gateways, $gateway ) );
	}


	/*
	* Gateway parameters
	*/
	public static function options() {
		return array(
			'username' => __( 'API Username', 'GF_SMS' ),
			'password' => __( 'API Password', 'GF_SMS' ),
		);
	}

	/*
	* Gateway credit
	*/
	public static function credit() {
		return true;
	}

	/*
	* Gateway action
	*/
	public static function process( $options, $action, $from, $to, $messages ) {

		if ( $action == 'credit' && ! self::credit() ) {
			return false;
		}

		$username = $options['username'];
		$password = $options['password'];

		if ( $action == "send" ) {

			$to = str_replace( '+', '', $to );

			$content = "http://gateway.onewaysms.sg:10002/api.aspx?apiusername=" . $username . "&apipassword=" . $password .
			           "&senderid=" . rawurlencode( $from ) . "&mobileno=" . rawurlencode( $to ) .
			           "&message=" . rawurlencode( stripslashes( $messages ) ) . "&languagetype=1";

			if ( extension_loaded( 'curl' ) ) {
				$ch = curl_init( $content );
				curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
				$response = curl_exec( $ch );
				curl_close( $ch );
			} else {
				$response = file_get_contents( $content );
			}

			if ( empty( $response ) ) {
				return __( 'Unknown Error.', 'GF_SMS' );
			}

			if ( stripos( $response, ',' ) !== false ) {
				$response = explode( ',', $response );
				foreach ( $response as $_response ) {
					if ( $_response <= 0 ) {
						return $_response . ' ::: ' . self::error( $_response );
					}
				}
			} else if ( is_numeric( $response ) && $response < 0 ) {
				return $response . ' ::: ' . self::error( $response );
			} else if ( ! is_numeric( $response ) ) {
				return __( 'Unknown Error.', 'GF_SMS' );
			}

			return 'OK';
		}


		if ( $action == "credit" ) {

			$content = "http://gateway.onewaysms.sg:10002/bulkcredit.aspx?apiusername=" . $username . "&apipassword=" . $password;

			if ( extension_loaded( 'curl' ) ) {
				$ch = curl_init( $content );
				curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
				$response = curl_exec( $ch );
				curl_close( $ch );
			} else {
				$response = file_get_contents( $content );
			}

			if ( isset( $response ) && is_numeric( $response ) ) {
				if ( $response >= 0 ) {
					return $response;
				} else {
					return __( 'Please Check API Username and Password.', 'GF_SMS' );
				}
			} else {
				return __( 'Unknown Error.', 'GF_SMS' );
			}

		}

		if ( $action == "range" ) {
			$min = 1000;
			$max = 2000;

			return array( "min" => $min, "max" => $max );
		}

	}

	private static function error( $status ) {

		switch ( $status ) {

			case '-100':
				return __( 'API username or password is invalid.', 'GF_SMS' );
				break;

			case '-200':
				return __( 'SenderId (From) parameter is invalid.', 'GF_SMS' );
				break;

			case '-300':
				return __( 'Mobile Number (Recievers) parameter is invalid.', 'GF_SMS' );
				break;

			case '-400':
				return __( 'languagetype is invalid.', 'GF_SMS' );
				break;

			case '-500':
				return __( 'Invalid characters in message.', 'GF_SMS' );
				break;

			case '-600':
				return __( 'Insufficient credit balance.', 'GF_SMS' );
				break;

			default:
				return __( 'Error.', 'GF_SMS' );
				break;
		}
	}

}